﻿using Infragistics.Windows;
using Infragistics.Windows.Controls;
using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Input;
using System.Windows.Media;

namespace Intel.IDMS.WRAP.Common.Styles.Intel
{
    public partial class XamDataGridStyles
    {
        private static Brush _lightBrush = (SolidColorBrush)(new BrushConverter().ConvertFrom("#FF5E95C1"));
        private bool _mouseOver = false;

        void Header_Loaded(object sender, RoutedEventArgs e)
        {
            LabelPresenter presenter = sender as LabelPresenter;
            SetIconColors(presenter);
        }

        void Header_MouseEnter(object sender, MouseEventArgs e)
        {
            _mouseOver = true;
            LabelPresenter presenter = sender as LabelPresenter;
            SetIconColors(presenter);
        }

        void Header_MouseLeave(object sender, MouseEventArgs e)
        {
            _mouseOver = false;
            LabelPresenter presenter = sender as LabelPresenter;
            SetIconColors(presenter);
        }

        void SetIconColors(LabelPresenter presenter)
        {
            Grid grid = Utilities.GetDescendantFromName(presenter, "sortIndicatorAndLabel") as Grid;

            SortIndicator indicator = Utilities.GetDescendantFromType(grid, typeof(SortIndicator), false) as SortIndicator;
            indicator.Background = Brushes.DarkGray;

            SummaryButton summary = Utilities.GetDescendantFromType(grid, typeof(SummaryButton), false) as SummaryButton;

            FixedFieldButton fixedfield = Utilities.GetDescendantFromType(grid, typeof(FixedFieldButton), false) as FixedFieldButton;

            if (_mouseOver)
            {
                if (presenter.SortStatus == SortStatus.NotSorted)
                {
                    summary.Foreground = Brushes.White;
                    fixedfield.Foreground = Brushes.White;
                }
                else
                {
                    summary.Foreground = Brushes.Black;
                    fixedfield.Foreground = Brushes.Black;
                }
            }
            else
            {
                if (presenter.SortStatus == SortStatus.NotSorted)
                {
                    summary.Foreground = Brushes.WhiteSmoke;
                    fixedfield.Foreground = Brushes.WhiteSmoke;
                }
                else
                {
                    summary.Foreground = Brushes.DarkGray;
                    fixedfield.Foreground = Brushes.DarkGray;
                }
            }
        }
    }

    // Do not carry these forward.

    public class IsNestedRowConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null)
            {
                var rec = value as SummaryRecord;
                if (rec.FieldLayout.Key.ToString() == "NestedRow")
                    return true;
            }

            return false;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
